// Creating a shape of the game field.
var WIDTH:int;
var HEIGHT:int;
var INTERVAL:float;
var SIZE:float;

function Start () {
	var quadIndexes:int[] = [0, 1, 2, 0, 2, 3];
	var mesh:Mesh = GetComponent(MeshFilter).mesh;
	var vertices = new Vector3[4 * 3 * WIDTH * HEIGHT];
	var colors = new Color[4 * 3 * WIDTH * HEIGHT];
	var indexes = new int[6 * 3 * WIDTH * HEIGHT];
	var i = 0;
	var x = -INTERVAL * (WIDTH  - 1) / 2;
	for (var xi = 0; xi < WIDTH; xi++) {
		var y = -INTERVAL * (HEIGHT - 1) / 2;
		for (var yi =0; yi < HEIGHT; yi++) {
			for (var zi = 0; zi < 3; zi++) {
				var vi = i * 4 * 3 + zi * 4;
				var z = (zi - 1) * SIZE;
				vertices[vi] = Vector3(x - SIZE, y - SIZE, z);
				vertices[vi + 1] = Vector3(x + SIZE, y - SIZE, z);
				vertices[vi + 2] = Vector3(x + SIZE, y + SIZE, z);
				vertices[vi + 3] = Vector3(x - SIZE, y + SIZE, z);
				for (var j = 0; j < 4; j++) {
					colors[vi + j] = Color(0.5, 1, 0.5, 0.25);
				}
				for (j = 0 ; j < 6; j++) {
					indexes[i * 6 * 3 + zi * 6 + j] = vi + quadIndexes[j];
				}
			}
			i++;
			y += INTERVAL;
		}
		x += INTERVAL;
	}
	mesh.vertices = vertices;
	mesh.colors = colors;
	mesh.triangles = indexes;
}
