// Creating a shape consist of squares.
var points:Vector3[];
var colors:Color[];
var size:float[];

function Start () {
	var quadIndexes:int[] = [0, 1, 2, 0, 2, 3];
	var mesh:Mesh = GetComponent(MeshFilter).mesh;
	var pointsCount = points.length;
	var vertices = new Vector3[4 * 7 * pointsCount];
	var pointColors = new Color[4 * 7 * pointsCount];
	var indexes = new int[6 * 7 * pointsCount];
	for (var i = 0; i < pointsCount; i++) {
		var p = points[i];
		var sz = size[i];
		for (var j = 0; j < 7; j++) {
			var z = p.z + sz / 3 * (j - 3);
			var s = sz * (1 - Mathf.Abs(j - 3) * 0.2);
			vertices[i * 4 * 7 + j * 4] = Vector3(p.x - s, p.y - s, z);
			vertices[i * 4 * 7 + j * 4 + 1] = Vector3(p.x + s, p.y - s, z);
			vertices[i * 4 * 7 + j * 4 + 2] = Vector3(p.x + s, p.y + s, z);
			vertices[i * 4 * 7 + j * 4 + 3] = Vector3(p.x - s, p.y + s, z);
		}
		for (j = 0; j < 4 * 7; j++) {
			pointColors[i * 4 * 7+ j] = colors[i];
		}
		for (j = 0 ; j < 6; j++) {
			for (var k = 0; k < 6; k++) {
				indexes[i * 6 * 7 + j * 6 + k] = i * 4 * 7  + j * 4 + quadIndexes[k];
			}
		}
	}
	mesh.vertices = vertices;
	mesh.colors = pointColors;
	mesh.triangles = indexes;
}