// Bombs falling to the player's bucket.
import UpdateScene;

var waterParticle:Transform;
var explosionParticle:Transform;
private var bucket:Transform;
private var speed:float;
private var particle:Transform;
private var flameGauges:UpdateFlameGauges;

function SetParams(b:Transform, s:float, p:Transform, fg:UpdateFlameGauges) {
	bucket = b;
	speed = s;
	particle = p;
	particle.transform.parent = transform;
	flameGauges = fg;
}

function Start () {
	var t = transform;
	var by = bucket.position.y + bucket.localScale.y + t.localScale.y;
	var bs = bucket.localScale.x + t.localScale.x;
	for (;;) {
		t.position.y -= speed * Time.deltaTime;
		if (t.position.y < -10) {
			if (isInGame) {
				Instantiate(explosionParticle, t.position, Quaternion.identity);
				flameGauges.AddFlame(t.position.x);
				ResetScoreIncrement();
			}
			break;
		}
		if (t.position.y < by && Mathf.Abs(bucket.position.x - t.position.x) < bs) {
			if (isInGame) {
				AddScore();
				Instantiate(waterParticle, t.position, Quaternion.identity);
			}
			break;
		}
		yield;
	}
	t.position = Vector3(10000, 10000, 10000);
	particle.transform.parent = null;
	yield WaitForSeconds(1);
	Destroy(particle.gameObject);
	Destroy(gameObject);
}