// Flame gauges and water gauges displayed at the bottom of the screen.
import Util;
import GetNumberKey;
import UpdateScene;

var flame:Transform;
var water:Transform;
private var flameHeights = new float[8];
private var waterHeights = new float[8];

function Initialize() {
	for (var i = 0; i < 8; i++) {
		flameHeights[i] = 0;
		waterHeights[i] = 0;
	}
}

function Start () {
	var flames = new Transform[8];
	var waters = new Transform[8];
	for (var i = 0; i < 8; i++) {
		flames[i] = Instantiate(flame, Vector3((i - 3.5) * 2, -10, 0), Quaternion.identity);
		waters[i] = Instantiate(water, Vector3((i - 3.5) * 2, -10, 0), Quaternion.identity);
	}
	Initialize();
	for (;;) {
		for (i = 0; i < 8; i++) {
			var f = flames[i];
			var sz = flameHeights[i] + RandZeroCenter(0.3);
			if (sz < 0)
				sz = 0;
			f.position.y = -9 + sz;
			f.localScale.y = sz;
			f.localScale.x = 1.0 + RandZeroCenter(0.2);
			var w = waters[i];
			if (keysDown[i]) {
				waterHeights[i] = 4;
			}
			flameHeights[i] -= 0.6 * Time.deltaTime;
			if (flameHeights[i] < 0)
				flameHeights[i] = 0;
			waterHeights[i] -= 24 * Time.deltaTime;
			if (waterHeights[i] < 0)
				waterHeights[i] = 0;
			sz = waterHeights[i];
			w.position.y = -9 + sz;
			w.localScale.y = sz;
		}
		yield;
	}
}

function AddFlame(y:float) {
	var i:float= y / 2 + 3.5;
	var o:float = i - Mathf.Floor(i);
	AddOneFlame(i, 1.0 - o);
	AddOneFlame(i + 1, o);
}

function AddOneFlame(i:int, h:float) {
	if (i < 0 || i >= 8)
		return;
	flameHeights[i] += 10 * h;
	if (isInGame && flameHeights[i] > 15)
		StartGameOver();
}
