// A title screen and a game over screen.
// Handling a score and a difficulty.
static var bombInterval:float;
static var bombSpeed:float;
static var bomberVel:float;
static var bomberVelRevRatio:float;
static var isInGame:boolean;
static var gameOverTime:float;
private static var scoreText:GUIText;
private static var score:int;
private static var scoreIncrement:int;
private static var waveText:GUIText;
private static var wave:int;
private static var nextSlowdownWave:int;
private static var titleText:GUIText;
private static var messageText:GUIText;
private static var bomber:AddBomb;

static function InitializeScene(st:GUIText, wt:GUIText, tt:GUIText, mt:GUIText, b:AddBomb) {
	scoreText = st;
	waveText = wt;
	titleText = tt;
	messageText = mt;
	bomber = b;
}

static function StartTitle() {
	isInGame = false;
	titleText.gameObject.active = true;
	messageText.gameObject.active = true;
	titleText.text = "DOKAAN";
	messageText.text = "Push [1]-[8] to start";
}

static function StartGame() {
	isInGame = true;
	titleText.gameObject.active = false;
	messageText.gameObject.active = false;
	score = 0;
	scoreIncrement = 1;
	DrawScore();
	wave = 1;
	DrawWave();
	nextSlowdownWave = 10;
	bombInterval = 1.0;
	bombSpeed = 10.0;
	bomberVel = 10.0;
	bomberVelRevRatio = 0.01;
	bomber.Initialize();
}

static function StartGameOver() {
	isInGame = false;
	gameOverTime = 2;
	titleText.gameObject.active = true;
	titleText.text = "GAME OVER";
}

static function AddScore() {
	score += scoreIncrement;
	DrawScore();
	scoreIncrement++;
	if (scoreIncrement > 10)
		scoreIncrement = 10;
}

static function ResetScoreIncrement() {
	scoreIncrement = 1;
}

static function GoToNextWave() {
	var rankUpRatio = 10.0 / (10.0 + wave);
	bombInterval *= (1 - 0.2 * rankUpRatio);
	bombSpeed += 5 * rankUpRatio;
	if (bomberVel < 0)
		bomberVel -=  5 * rankUpRatio;
	else
		bomberVel += 5 * rankUpRatio;
	bomberVelRevRatio += 0.004 * rankUpRatio;
	wave++;
	DrawWave();
	if (wave >= nextSlowdownWave) {
		nextSlowdownWave += 10;
		var rankDownRatio = 20.0 / (20.0 + wave);
		bombInterval *= (1 + 1.0 * rankDownRatio);
		bomberVel *= (1 - 0.75 * rankDownRatio);
		bomberVelRevRatio *= (1 - 0.75 * rankDownRatio);
		if (wave >= 50)
			rankDownRatio /= 2;
		bombSpeed *= (1 - 0.75 * rankDownRatio);
	}
}

static function DrawScore() {
	scoreText.text = score.ToString();
}

static function DrawWave() {
	waveText.text = "WAVE " + wave.ToString();
}
